CEL: Crystal Entity Layer: iPcMechanicsBalancedGroup Struct Reference (CEL: Crystal Entity Layer Public API Reference)

| ## Public API Reference

- Main Page
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# iPcMechanicsBalancedGroup Struct Reference

Property class representing a balanced group of thrusters that can translate or rotate the object in a certain axis. More...

`#include <propclass/mechthruster.h>`

List of all members.

## Public Member Functions
virtual void | AddThruster (iPcMechanicsThruster *thruster, float multiplier)=0
| Add a thruster to this thruster group.
virtual float | AvailableThrust ()=0
| What is the maximum amount of thrust that can be applied to the thrusters in this group?
virtual float | AvailableThrustForce ()=0
| Get the amount of force that the maximum thrust for this group would produce.
virtual void | ChangeThrust (float deltathrust)=0
| Apply the given thrust to all thrusters in this balanced group.
virtual iPcMechanicsThruster * | GetThruster (const char *tag)=0
| Get the associated thruster.
virtual celAxisType | GetType ()=0
| Get this group's type.
virtual void | RemoveThruster (const char *tag)=0
| Remove a thruster.
virtual void | SetType (celAxisType type)=0
| Set this group's type.

## Detailed Description

Property class representing a balanced group of thrusters that can translate or rotate the object in a certain axis.

This property class supports the following actions (add prefix 'cel.action.' to get the ID of the action and add prefix 'cel.parameter.' to get the ID of the parameter):

- SetType: parameters 'type' (string, "rotation" or "translation").
- AddThruster: parameters 'thrusterpctag' (string), 'multiplier' (float).

Definition at line 140 of file mechthruster.h.

## Member Function Documentation

virtual void iPcMechanicsBalancedGroup::AddThruster | ( | iPcMechanicsThruster * | thruster,
|  | float | multiplier |
| ) |  |  | `[pure virtual]`

Add a thruster to this thruster group.

At least one is required.

Parameters:

  | thruster | the thruster to add to this group.
  | multiplier | the percentage of the maximum thrust of this thruster to use when activated through this balanced group. (must be >0 and <=1)

virtual float iPcMechanicsBalancedGroup::AvailableThrust | ( |  | ) | `[pure virtual]`

What is the maximum amount of thrust that can be applied to the thrusters in this group?

virtual float iPcMechanicsBalancedGroup::AvailableThrustForce | ( |  | ) | `[pure virtual]`

Get the amount of force that the maximum thrust for this group would produce.

virtual void iPcMechanicsBalancedGroup::ChangeThrust | ( | float | deltathrust | ) | `[pure virtual]`

Apply the given thrust to all thrusters in this balanced group.

Parameters:

  | deltathrust | the amount of thrust to apply. (must be > 0)

virtual iPcMechanicsThruster* iPcMechanicsBalancedGroup::GetThruster | ( | const char * | tag | ) | `[pure virtual]`

Get the associated thruster.

Parameters:

  | tag | the tag of the thruster to retrieve from the group.

virtual celAxisType iPcMechanicsBalancedGroup::GetType | ( |  | ) | `[pure virtual]`

Get this group's type.

virtual void iPcMechanicsBalancedGroup::RemoveThruster | ( | const char * | tag | ) | `[pure virtual]`

Remove a thruster.

Parameters:

  | tag | the tag of the thruster to add to the group.

virtual void iPcMechanicsBalancedGroup::SetType | ( | celAxisType | type | ) | `[pure virtual]`

Set this group's type.

Parameters:

  | type | one of celAxisType, the type of thruster this is.

The documentation for this struct was generated from the following file:

- propclass/mechthruster.h